


local setRadarSelection = radar.SetRadarSelection
local pCommand = gkinterface.GKProcessCommand
local floor = math.floor
local targetString = ""


------------------------
-- cargo tab
------------------------

-- cargo finder
function Cargo_tab.T.Tab.findCargo(data, args)
	Cargo_tab.T.Tab.saveLists = unspickle(LoadSystemNotes(Cargo_tab.T.Tab.systemnotes));
	local searchItem = " "
	local searchID1 = args[1]
	local searchID2 = args
	local cargoNumber = searchID1
	if args then
		if cargoNumber == nil then
			cargoNumber = searchID2
		end
		
		if cargoNumber == "a1" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[1][3])
			searchItem = tableString
		elseif cargoNumber == "a2" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[2][3])
			searchItem = tableString
		elseif cargoNumber == "a3" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[3][3])
			searchItem = tableString
		elseif cargoNumber == "a4" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[4][3])
			searchItem = tableString
		elseif cargoNumber == "a5" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[5][3])
			searchItem = tableString
		elseif cargoNumber == "a6" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[6][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "a7" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[7][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "a8" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[8][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "a9" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[9][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "a0" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.cargoList[10][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b1" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[1][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b2" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[2][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b3" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[3][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b4" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[4][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b5" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[5][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b6" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[6][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b7" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[7][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b8" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[8][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b9" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[9][3]) or ""
			searchItem = tableString
		elseif cargoNumber == "b0" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.dropsList[10][3]) or ""
			searchItem = tableString
		else
			searchItem = "Invalid Item. a1-a0 and b1-b0 only."
			
		end
		
		
		local currentItem = ""
		local itemFound = 0
		if searchItem ~= "" then
			-- start radar search at zero
			setRadarSelection(0,0)
			-- search through all items in range until something matches
			while (currentItem ~= nil and itemFound == 0) do
				pCommand("RadarNext");
				-- check found item 
				currentItem = GetTargetInfo()
				-- compare current item with the search item
				if (currentItem ~= nil and string.find(string.lower(currentItem),string.lower(searchItem))) then
					-- end the loop, cargo found
					itemFound = 1
				end
			end
			-- nothing found, still zero
			if itemFound == 0 then
				print("\127504aff** No cargo in range with: " .. "\127ff0000" .. searchItem .. "\127o")
				pCommand("RadarNextNearestEnemy")
			end
		else
			print("\127504aff**No Search Item specified. Use /mdicargo to set up search terms.\127o")
		end
	else
		print("\127504aff**You need to specify an item, a1-a0 for the first cargo page, b1-b0 for the second cargo page.\127o")
	end
end




------------------------
-- features tab
------------------------


-- start autotarget function on/off switch
function Cargo_tab.T.Tab.autoTargetSwitch()
	if Cargo_tab.T.Tab.autoTarget == false then
		Cargo_tab.T.Tab.autoTarget = true
		RegisterEvent(Cargo_tab.T.Tab.playerDied, "PLAYER_DIED")
		print("\127a134eb** AutoTarget: ON\127o")
	elseif Cargo_tab.T.Tab.autoTarget == true then
		Cargo_tab.T.Tab.autoTarget = false
		Cargo_tab.T.Tab.distanceOnOffSwitch = false
		UnregisterEvent(Cargo_tab.T.Tab.playerDied, "PLAYER_DIED")
		print("\127a134eb** AutoTarget: OFF\127o")	
	end
end


-- start distancecheck function on/off switch
function Cargo_tab.T.Tab.distanceCheckSwitch()
	if Cargo_tab.T.Tab.distanceOnOffSwitch == false then
		-- set variable to true to turn the check on and meet if condition
		Cargo_tab.T.Tab.distanceOnOffSwitch = true;
		print("\127a134eb** AutoTarget: Distance check ON\127o");
		-- call the function, this time with a real function call
		Cargo_tab.T.Tab.checkDistance()
	elseif Cargo_tab.T.Tab.distanceOnOffSwitch == true then
		-- kill any remaining timers to prevent unforseen behavior
		if Cargo_tab.T.Tab.distanceTimer:IsActive() then Cargo_tab.T.Tab.distanceTimer:Kill() end
		-- set condition to false to interrupt the loop
		Cargo_tab.T.Tab.distanceOnOffSwitch = false
		print("\127a134eb** AutoTarget: Distance check OFF\127o");
	else
		Cargo_tab.T.Tab.distanceOnOffSwitch = false
		print("\127a134ebSomething went wrong. Disabling distance check.\127o")
	end
end



-- function to target nearest enemy once current target dies, called by autoTargetSwitch
function Cargo_tab.T.Tab.playerDied(event, victim, killer, weapon)
    -- assign all the event data to variables
    local owncharID = GetCharacterID()
    local ownName = GetPlayerName(owncharID)
    local victimName = GetPlayerName(victim)
    local killerName = GetPlayerName(killer)
    local usedWeapon = weapon
    local currentTarget = GetTargetInfo()
	-- if you killed a bot, switch to nearest one
	if killerName == ownName then
		pCommand("RadarNextNearestEnemy")
	-- someone else killed your target, switch to nearest
	elseif victimName == currentTarget then
		pCommand("RadarNextNearestEnemy")
	end
    
end


-- distance check every 4 seconds, retarget nearest hostile, called by distanceCheckSwitch
function Cargo_tab.T.Tab.checkDistance()
	if Cargo_tab.T.Tab.autoTarget == true then
		if Cargo_tab.T.Tab.distanceOnOffSwitch == true then
			-- target nearest hostile
			pCommand("RadarNextNearestEnemy")
			-- re-allocate the timer because timers in vo are stupid af
			Cargo_tab.T.Tab.distanceTimer = Timer()
			-- recall the function after 4 seconds, function call needs to be a variable and not a function call because lua is dumb
			Cargo_tab.T.Tab.distanceTimer:SetTimeout(4000, Cargo_tab.T.Tab.checkDistance)
		end
	else
		print("\127a134eb** AutoTarget is OFF, distance check disabled.\127o")
	end
end



-- send target to various chats
function Cargo_tab.T.Tab.targetDetails(channel)
    -- only fill in if there are target details
	if GetTargetInfo() ~= nil then
        -- fill in all the available stats
		local targetName, targetHealth, targetDistance, targetFactionID, targetGuild, targetShip = GetTargetInfo()
		local targetCharID = GetCharacterIDByName(targetName)
        -- if roids, only report name and distance
		if targetName == "Asteroid" or targetName == "Ice Crystal" then 
            targetString = "Target: " .. targetName .. " at " .. floor(targetDistance) .. "m."
        -- if it has health, it must be a player
        elseif targetHealth ~= nil then
            local factionInfo = FactionName[targetFactionID] or "";
            local guildTag = "[" .. targetGuild .. "]" or "";
            if targetGuild ~= "" then
                targetString = "Target: " .. guildTag .. targetName .. " (" .. factionInfo .. "), (" .. targetCharID .. "), piloting " .. Article(targetShip) .. " with ".. floor(targetHealth*100) .."% health at ".. floor(targetDistance) .. "m."  
            else
                targetString = "Target: " .. targetName .. " (" .. factionInfo .. "), (" .. targetCharID .. "), piloting " .. Article(targetShip) .." with " .. floor(targetHealth*100) .."% health at " .. floor(targetDistance) .. "m."
            end
		-- if it's neither roid or player, it must be cargo. separated for future additions
        else 
            targetString = "Target: " .. targetName .. " at " .. floor(targetDistance) .. "m."
		end
        -- send the actual targetString to channel 
        SendChat(targetString, channel:upper())
	end
end


-- function to bind targetDetails to guild chat
function Cargo_tab.T.Tab.postTargetGuild()
	Cargo_tab.T.Tab.targetDetails("GUILD")
end


-- function to bind targetDetails to group chat
function Cargo_tab.T.Tab.postTargetGroup()
	Cargo_tab.T.Tab.targetDetails("GROUP")
end


-- function to bind targetDetails to active channel
function Cargo_tab.T.Tab.postTargetChannel()
	Cargo_tab.T.Tab.targetDetails("CHANNEL")
end


-- plot to home station
function Cargo_tab.T.Tab.goHome()
	local homeSectorID = GetHomeStation()
	local homeLocation = AbbrLocationStr(homeSectorID)
	NavRoute.SetFinalDestination(homeSectorID)
	print("\1277dd4ff** Navroute plotted to: " .. homeLocation .. "\127o")
end


--[[ no longer supported 
-- turn target friendly on radar
function Cargo_tab.T.Tab.turnFriendly()
	local delayTimer = Timer()
	local targetName, targetHealth, targetDistance, targetFactionid, targetGuild, targetShip = GetTargetInfo()
	local targetCharId = GetCharacterIDByName(targetName)
	local targetNodeID = GetPlayerNodeID(targetCharId)
	function GetFriendlyStatus(targetCharID)
		return 3
	end
	delayTimer:SetTimeout(64, function() UpdateRadarFriendlyStatus(targetNodeID) end)
end


-- turn target hostile on radar
function Cargo_tab.T.Tab.turnHostile()
	local delayTimer = Timer()
	local targetName, targetHealth, targetDistance, targetFactionid, targetGuild, targetShip = GetTargetInfo()
	local targetCharId = GetCharacterIDByName(targetName)
	local targetNodeID = GetPlayerNodeID(targetCharId)
	function GetFriendlyStatus(targetCharID)
		return 0
	end
	delayTimer:SetTimeout(64, function() UpdateRadarFriendlyStatus(targetNodeID) end)
end

--]]



------------------------
-- nav tab
------------------------


-- navigation
function Cargo_tab.T.Tab.navPlot(data, args)
	Cargo_tab.T.Tab.saveLists = unspickle(LoadSystemNotes(Cargo_tab.T.Tab.systemnotes));
	local sectorLocation = ""
	local searchID1 = args[1]
	local searchID2 = args
	local navNumber = searchID1

	if args then
		-- account for calling the function both from the targetlist (args) and by direct keybind (args[1])
		if navNumber == nil then
			navNumber = searchID2
		end
		-- find args value in nav table
		if navNumber == "n2" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[2][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n3" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[3][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n4" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[4][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n5" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[5][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n6" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[6][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n7" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[7][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n8" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[8][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n9" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[9][3]) or ""
			sectorLocation = tableString
		elseif navNumber == "n0" then
			local tableString = filter_colorcodes(Cargo_tab.T.Tab.saveLists.navList[10][3]) or ""
			sectorLocation = tableString
		else
			sectorLocation = ""	
		end
		-- plot to destination
		local sectorID = SectorIDFromLocationStr(sectorLocation)
		if sectorLocation ~= "" then
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
		else
			print("\1277dd4ff** No navigation data, no route plotted.\127o")
		end
	else
		print("\1277dd4ff** No args specified. n1-n0 only.\127o")
	end
end


