--[[
	Cargo Tab written by Seryn
	version 1.3.0 public
	based on mdi-targetlist tab system by draugath
--]]

declare("Cargo_tab", {
	version = "1.3.0",
})


local T = {
	Tab = {
		title = "Cargo",
		columns = {
			{
				title = "Index",
				width = 0,
			},
			{
				title = "Item",
				width = 1,
			},
		},
		filters = {
			{
				title = "Cargo",
				pages = {
					{
						title = "Cargo A",
						fgcolor = "113 227 144 225 *",
						bgcolor = "52 116 235 225 *",
					},	
					{
						title = "Cargo B",
						fgcolor = "52 192 235 225 *",
						bgcolor = "34 49 163 225 *",
					},
				},
			},
			{
				title = "Features",
			},
			{
				title = "Nav",
			},
		},
		--------------
		

		currentList = {},
		filter_index = -1,
	}
}

Cargo_tab.T = T
T.Tab.cargoList = {}
T.Tab.dropsList = {}
T.Tab.featureList = { 
	{
		"1",
		"\127b07395** Autotarget ON/OFF",
	},
	{
		"2",
		"\127d8808e** Autotarget Distance Check",
	},
	{	
		"3",
		"\127ffa583** Post Target to Group",
	},
	{	
		"4",
		"\127ffc38c** Post Target to Guild",
	},
	{	
		"5",
		"\127ffe5b1** Post Target to active channel",
	},
	{	
		"6",
		"\127fff190** Plot route home",
	},
}

T.Tab.navList = {}

T.Tab.colors = {
	"b07395",
	"d8808e",
	"ffa583",
	"ffc38c",
	"ffe5b1",
	"fff190",
	"ff7070",
	"a168f1",
	"7770ff",
	"3170ff",
}

T.Tab.autoTarget = false
T.Tab.distanceOnOffSwitch = false
T.Tab.targetMode = 1
T.Tab.targetTimer = Timer()
T.Tab.distanceTimer = Timer()
T.Tab.autoLoadCargo = false
T.Tab.autoUnloadCargo = false
T.Tab.saveLists = {}
T.Tab.systemnotes = 1120003471
T.Tab.systemnotesOld = 1120003472

local setRadarSelection = radar.SetRadarSelection
local pCommand = gkinterface.GKProcessCommand

dofile("settings.lua")
dofile("functions.lua")	


-- tab change to Cargo, update list.. maybe useful later
function T.Tab:TARGETLIST_TAB_CHANGED()
	self.is_active = targetlist.API.IsActiveTab(T.Tab)
	if (self.is_active) then
		T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes)) 
		T.Tab.cargoList = T.Tab.saveLists.cargoList
		T.Tab.dropsList = T.Tab.saveLists.dropsList
		T.Tab.navList = T.Tab.saveLists.navList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end



function T.Tab:ChangeFilter(index, page)
	T.Tab.filter_index = index
	T.Tab.filter_page = page
	T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes));
	T.Tab.cargoList = T.Tab.saveLists.cargoList
	T.Tab.dropsList = T.Tab.saveLists.dropsList
	T.Tab.navList = T.Tab.saveLists.navList
	if self.filter_index == 1 and self.filter_page == 1 then
		T.Tab.currentList = T.Tab.cargoList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 1 and self.filter_page == 2 then
		T.Tab.currentList = T.Tab.dropsList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 2 then
		T.Tab.currentList = T.Tab.featureList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 3 then
		T.Tab.currentList = T.Tab.navList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end


-- select target to find cargo 
function T.Tab:ChangeTarget(_, listEntryID)
	-- cargo finder
	if self.filter_index == 1 and self.filter_page == 1 then
		T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local listEntryID = listEntryID
		local arg = ""
		-- find first item in list A
		if listEntryID == 1 then
			arg = "a1"

		-- find second item in list A
		elseif listEntryID == 2 then
			arg = "a2"

		-- find third item in list A
		elseif listEntryID == 3 then
			arg = "a3"

		--
		elseif listEntryID == 4 then
			arg = "a4"
			
		--
		elseif listEntryID == 5 then
			arg = "a5"

		--
		elseif listEntryID == 6 then
			arg = "a6"

		--
		elseif listEntryID == 7 then
			arg = "a7"

		--
		elseif listEntryID == 8 then
			arg = "a8"

		--
		elseif listEntryID == 9 then
			arg = "a9"

		--
		elseif listEntryID == 10 then
			arg = "a0"
		end

		-- call findcargo function with arg
		Cargo_tab.T.Tab.findCargo(_, arg)

	-- second set of search items
	elseif self.filter_index == 1 and self.filter_page == 2 then
		T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local listEntryID = listEntryID
		local arg = ""

		-- find first item in list B
		if listEntryID == 1 then
			arg = "b1"

		-- find second item in list B
		elseif listEntryID == 2 then
			arg = "b2"

		-- find third item in list B
		elseif listEntryID == 3 then
			arg = "b3"

		--
		elseif listEntryID == 4 then
			arg = "b4"

		-- 
		elseif listEntryID == 5 then
			arg = "b5"

		-- 
		elseif listEntryID == 6 then
			arg = "b6"

		-- 
		elseif listEntryID == 7 then
			arg = "b7"

		--
		elseif listEntryID == 8 then
			arg = "b8"

		--
		elseif listEntryID == 9 then
			arg = "b9"

		--
		elseif listEntryID == 10 then
			arg = "b0"
		end
		
		-- call findcargo function with arg
		Cargo_tab.T.Tab.findCargo(_, arg)


	-- various tools
	elseif self.filter_index == 2 then
		local listEntryID = listEntryID
		-- autotarget on/off switch
		if listEntryID == 1 then
			Cargo_tab.T.Tab.autoTargetSwitch()

		-- autotarget distance check
		elseif listEntryID == 2 then
			Cargo_tab.T.Tab.distanceCheckSwitch()
			
		-- post target to group
		elseif listEntryID == 3 then
			Cargo_tab.T.Tab.targetDetails("GROUP")

		-- post target to guild
		elseif listEntryID == 4 then
			Cargo_tab.T.Tab.targetDetails("GUILD")

		-- post target to active channel
		elseif listEntryID == 5 then
			Cargo_tab.T.Tab.targetDetails("CHANNEL")

		-- plot route to home station
		elseif listEntryID == 6 then
			Cargo_tab.T.Tab.goHome()

		-- turn target friendly on radar
		elseif listEntryID == 7 then
			return

		-- turn target hostile on radar
		elseif listEntryID == 8 then
			return

		-- autoload on/off
		elseif listEntryID == 9 then
			return
		-- autounload on/off
		elseif listEntryID == 10 then
			return
		end

	
	-- nav list
	elseif self.filter_index == 3 then
		local listEntryID = listEntryID
		local arg = ""

		-- plot to home
		if listEntryID == 1 then
			Cargo_tab.T.Tab.goHome()

		-- plot to nyrius f-6
		elseif listEntryID == 2 then
			arg = "n2"

			-- plot to pel c12
		elseif listEntryID == 3 then
			arg = "n3"

		-- plot to brac m14
		elseif listEntryID == 4 then
			arg = "n4"
			
		-- plot to lat i8
		elseif listEntryID == 5 then
			arg = "n5"
		
		-- plot to odia m-14
		elseif listEntryID == 6 then
			arg = "n6"

		-- latos n-2
		elseif listEntryID == 7 then
			arg = "n7"

		-- dau l-10
		elseif listEntryID == 8 then
			arg = "n8"

		--
		elseif listEntryID == 9 then
			arg = "n9"

		--
		elseif listEntryID == 10 then
			arg = "n0"

		end
		if listEntryID ~= 1 then
			-- call navPlot function with arg
			Cargo_tab.T.Tab.navPlot(_, arg)
		end
	end
end





-- check if plugin was loaded correctly
function T.Tab:PLUGINS_LOADED()
	if (isdeclared("targetlist") and targetlist.API) then
		if (targetlist.API.Version >= 1) then
			targetlist.API.RegisterTab(T.Tab)
		else
			print("\1277dd4ffMDI-TargetList API version is not compatible. Cargo Tab was not loaded.\127o")
		end
	end
end

-- check if targetlist is even installed
function T.Tab:PLAYER_ENTERED_GAME()
	if (not (isdeclared("targetlist") and targetlist.API)) then
		print("\1277dd4ffCargo Tab for MDI-TargetList requires version 4 or higher.\127o")
	end
end



RegisterEvent(T.Tab, "TARGETLIST_TAB_CHANGED")
RegisterEvent(T.Tab, "PLUGINS_LOADED")
RegisterEvent(T.Tab, "PLAYER_ENTERED_GAME")
RegisterUserCommand("findcargo", Cargo_tab.T.Tab.findCargo)
RegisterUserCommand("autotarget", Cargo_tab.T.Tab.autoTargetSwitch)
RegisterUserCommand("autodistance", Cargo_tab.T.Tab.distanceCheckSwitch)
RegisterUserCommand("tigroup", Cargo_tab.T.Tab.postTargetGroup)
RegisterUserCommand("tiguild", Cargo_tab.T.Tab.postTargetGuild)
RegisterUserCommand("tichannel", Cargo_tab.T.Tab.postTargetChannel)